//AB/ Project Export XML View 1
//AB/ Object prj is a View_Project
//AB/     Set ProjectName to "Export XML View 1"
//AB/     Set ProjectFileName to "ExportXML.VW"
//AB/     Set GenerateFileName to "NONAME2"

// Project Object Structure
//   oXMLExportView is a dbView
//     oContainer is a Container3d
//       oFileListTreeView is a TreeView
//       oFieldsGrid is a Grid
//       oFileNameForm is a Form
//       oSelectAllExportButton is a Button
//       oCRLFAtRootCheckbox is a CheckBox
//     oExportButton is a Button

// Register all objects
Register_Object oContainer
Register_Object oCRLFAtRootCheckbox
Register_Object oExportButton
Register_Object oFieldsGrid
Register_Object oFileListTreeView
Register_Object oFileNameForm
Register_Object oSelectAllExportButton
Register_Object oXMLExportView


//AB/ AppBuild VIEW


//AB-StoreTopStart
// Include the package to the XML classes
Use FleXML.Pkg
//AB-StoreTopEnd

//AB-IgnoreStart

Use DfTreeVw.pkg

//AB-IgnoreEnd

DEFERRED_VIEW Activate_oXMLExportView FOR ;
;
Object oXMLExportView is a dbView
    Set Border_Style to Border_Thick
    Set Label to "XML Export View"
    Set Size to 201 416
    Set Location to 6 6
    Set piMinSize to 201 416

    //AB-DDOStart


    //AB-DDOEnd

    Object oContainer is a Container3d
        Set Size to 162 405
        Set Location to 5 5
        Set peAnchors to anAll
        Object oFileListTreeView is a TreeView
            Set peAnchors to anTopBottomLeft
            Set Size to 136 223
            Set Location to 5 5

            //AB-StoreStart
            // When the treeview is constructed we read the current filelist. For each entry of the
            // filelist a root item of the treeview is created. There is no usage of bitmaps in this
            // treeview to reduce the complexness of the sample application.
            Procedure OnCreateTree
                Integer iFile
                Handle hVoid
                String sDisplayName
            
                Repeat
                    Get_Attribute DF_FILE_NEXT_USED Of iFile To iFile
                    If (iFile > 0) Begin
                        Get_Attribute DF_FILE_DISPLAY_NAME Of iFile To sDisplayName
                        Get AddTreeItem sDisplayName 0 iFile 0 0 To hVoid
                    End
                Until (iFile = 0)
            End_Procedure  // OnCreateTree
            
            // When the user selects a different file from the treeview
            // we will request our fieldsgrid for an update of its list content
            Procedure OnItemChanged Handle hItemNew Handle hItemOld
                Integer iFile
            
                Get ItemData hItemNew To iFile
                Send DoFillFieldsGrid Of oFieldsGrid iFile
            End_Procedure // OnItemChanged
            //AB-StoreEnd

        End_Object    // oFileListTreeView

        Object oFieldsGrid is a Grid
            Set Size to 117 161
            Set Location to 5 233
            Set peAnchors to anAll
            Set peResizeColumn to rcAll

            Set Line_Width to 4 0

            Set Form_Width    item 0 to 75
            Set Header_Label  item 0 to "FieldName"
            
            Set Form_Width    item 1 to 20
            Set Header_Label  item 1 to "Export"
            
            Set Form_Width    item 2 to 20
            Set Header_Label  item 2 to "CR/LF"
            
            Set Form_Width    item 3 to 40
            Set Header_Label  item 3 to "IndentLevel"
            

            //AB-StoreStart
            // We do want checkboxes to operate correctly
            Set Select_Mode To Multi_Select
            
            // This property will be used to store the filenumber of the
            // fields shown in this grid for usage of export.
            Property Integer piDataFile
            
            // Add status pane help for column.
            Set Status_Help Item 0 To "Fieldname"
            Set Status_Help Item 1 To "Export this field?"
            Set Status_Help Item 2 To "Add CR/LF after adding field"
            Set Status_Help Item 3 To "How much TABS for indenting"
            
            // Create a spinform when entering the 4th column.
            Set Form_Button Item 3 To Form_Button_Spin
            
            // This method will set the select_state of all checkboxes in
            // the grid to false or true to help the user.
            Procedure DoToggleSelectAll Boolean bSelectAll
                Integer iItem iItems
            
                Set Dynamic_Update_State To False
                Move (Item_Count (Self) - 1) To iItems
                For iItem From 0 To iItems
                    If (Checkbox_Item_State (Self, iItem) = Dftrue) Begin
                        Set Select_State Item iItem To bSelectAll
                    End
                Loop
                Set Dynamic_Update_State To True
            End_Procedure // DoToggleSelectAll
            
            // Augment this existing event to only select checkboxes and
            // thus not selecting the fieldname and number of indents columns
            Procedure Select_Toggling Integer iItem Integer iState
                Integer iColumn iSelectCount
            
                If (iItem = CURRENT) Begin
                    Get Current_Item To iItem
                End
                Move (Mod (iItem, 4)) To iColumn
                If (iColumn = 1 Or iColumn = 2) Begin
                    Forward Send Select_Toggling iItem iState
                End
                Get Select_Count To iSelectCount
                Send DoSetButtonLabel Of oSelectAllExportButton (iSelectCount <> 0)
            End_Procedure // Select_Toggling
            
            // Here we create a normal item in the grid and set the
            // following properties:
            // - Message: Set to MSG_NONE (a double click will do nothing then)
            // - Aux_Value: Set to the passed value (any integer but in our case the fieldnumber)
            // - Value: Set to the contents of sText
            // The bEditable parameter says whether the item should be editable or not.
            Procedure DoAddItem String sText Integer iAuxValue Integer bEditAble
                Integer iItem
            
                Send Add_Item Msg_None sText
                Move (Item_Count (Self) - 1) To iItem
                Set Entry_State Item iItem To bEditAble
                Set Aux_Value Item iItem To iAuxValue
            End_Procedure // DoAddItem
            
            // This method creates a checkboxitem in the grid.
            Procedure DoAddCheckboxItem
                Send Add_Item Msg_None ""
                Set Checkbox_Item_State Item (Item_Count (Self) - 1) To True
            End_Procedure // DoAddCheckboxItem
            
            // This method will find all the fields for the passed filenumber
            // and list them in the grid. The errors 75 and 4177 are ignored,
            // the code checks whether the file is opened before enumerating
            // the fieldnames. The dynamic_update_state is used to defer the
            // painting (making the routine faster).
            Procedure DoFillFieldsGrid Integer iFile
                Boolean bOpened
                Integer iFields iField
                String sFieldName
            
                Set Dynamic_Update_State To False
                Send Delete_Data
                Send Ignore_Error Of Error_Object_Id DFERR_CANT_OPEN_DATA_FILE
                Send Ignore_Error Of Error_Object_Id DFERR_FILE_ACCESS_VIOLATION
                Open iFile
                Get_Attribute DF_FILE_OPENED Of iFile To bOpened
                If (bOpened) Begin
                    Set piDataFile To iFile
                    Get_Attribute DF_FILE_NUMBER_FIELDS Of iFile To iFields
                    For iField From 0 To iFields
                        Get_Attribute DF_FIELD_NAME Of iFile iField To sFieldName
                        Send DoAddItem sFieldName iField Dffalse
                        Send DoAddCheckboxItem
                        Send DoAddCheckboxItem
                        Send DoAddItem 0 0 Dftrue
                    Loop
                End
                Else Begin
                    Set piDataFile To 0
                End
                Send Trap_Error Of Error_Object_Id DFERR_CANT_OPEN_DATA_FILE
                Send Trap_Error Of Error_Object_Id DFERR_FILE_ACCESS_VIOLATION
                Close iFile
                Send Beginning_Of_Data
                Set Dynamic_Update_State To True
                Send DoSetButtonLabel Of oSelectAllExportButton False
            End_Procedure // DoFillFieldsGrid
            
            // This method adds a the data of all fields marked for export
            // in the grid as XML child of the passed XML Node ID in hoRecord.
            // Special in this routine is the adding/inserting of CR/LF and TAB
            // characters for linebreaks and indentation.
            Procedure DoAddFieldsData Integer hoRecord Integer iFile String sCRLF
                Integer iItem iItems iField iIndentLevel
                Boolean bExportField bAddCRLF
                String sFieldName sFieldData sIndentData
            
                Move (Item_Count (Self) - 1) To iItems
                For iItem From 0 To iItems
                    Get Select_State Item (iItem + 1) To bExportField
                    If (bExportField) Begin
                        Get Value Item (iItem + 3) To iIndentLevel
                        If (iIndentLevel > 0) Begin
                            Move (Repeat (Character (9), iIndentLevel)) To sIndentData
                            If (sIndentData <> "") Begin
                                Send AddChildTextNode Of hoRecord sIndentData
                            End
                        End
            
                        Get Value Item iItem To sFieldName
                        Get Aux_Value Item iItem To iField
                        Get_Field_Value iFile iField To sFieldData
                        Send AddElement Of hoRecord sFieldName sFieldData
            
                        Get Select_State Item (iItem + 2) To bAddCRLF
                        If (bAddCRLF) Begin
                            If (sCRLF <> "") Begin
                                Send AddChildTextNode Of hoRecord sCRLF
                            End
                        End
                    End
                    Move (iItem + 3) To iItem
                Loop
            End_Procedure // DoAddFieldsData            
            //AB-StoreEnd

        End_Object    // oFieldsGrid

        Object oFileNameForm is a Form
            Set Label to "Filename:"
            Set Size to 13 355
            Set Location to 143 41
            Set peAnchors to anBottomLeftRight
            Set Label_Col_Offset to 2
            Set Label_Justification_Mode to jMode_Right
        End_Object    // oFileNameForm

        Object oSelectAllExportButton is a Button
            Set Label to "Select Export All"
            Set Size to 14 65
            Set Location to 124 329
            Set peAnchors to anBottomRight

            //AB-StoreStart
            // When the user clicks this button we will set the select state
            // of ALL checkboxes in the grid to TRUE or FALSE based on the
            // fact if one or more item was selected before.
            Procedure OnClick
                Integer hoFieldsGrid iSelectCount
            
                Move oFieldsGrid To hoFieldsGrid
                Get Select_Count Of hoFieldsGrid To iSelectCount
                Send DoToggleSelectAll Of hoFieldsGrid (iSelectCount = 0)
                Send DoSetButtonLabel (iSelectCount = 0)
            End_Procedure // OnClick
            
            // Here we toggle the button label to reflect the action we
            // are going to take when it is clicked.
            Procedure DoSetButtonLabel Boolean bNotSelected
                If (bNotSelected) Begin
                    Set Label To "Deselect Export All"
                End
                Else Begin
                    Set Label To "Select Export All"
                End
            End_Procedure // DoSetButtonLabel            
            //AB-StoreEnd

        End_Object    // oSelectAllExportButton

        Object oCRLFAtRootCheckbox is a CheckBox
            Set Label to "CR/LF at root"
            Set Size to 10 60
            Set Location to 126 233
            Set peAnchors to anBottomLeft
        End_Object    // oCRLFAtRootCheckbox


        //AB-StoreStart
        // This method checks before the real export is done:
        // 1. Is there a filenumber in the property piDataFile of the grid
        // 2. If the file can be opened
        // 3. If you have specified a filename for the XML output
        // 4. If it can create an XML object
        // 5. If it can create a root element in the XML structure
        // When the export starts a CR/LF is added to the inner part of the 
        // root element if the checkbox oCRLFAtRootCheckbox is checked to make
        // sure all lines do have a CR/LF if desired.
        Procedure DoExportData
            String sFileName sCRLF
            Boolean bEof bSaveErr bOpened bCRLFAtRoot
            Integer hoXML hoRoot hoFieldsGrid iDataFile hoRecord
        
            Move oFieldsGrid To hoFieldsGrid
        
            Get piDataFile Of hoFieldsGrid To iDataFile
            If (iDataFile = 0) Begin
                Error 303 "No datafile number found!"
                Procedure_Return
            End
        
            Send Ignore_Error Of Error_Object_Id DFERR_CANT_OPEN_DATA_FILE
            Send Ignore_Error Of Error_Object_Id DFERR_FILE_ACCESS_VIOLATION
            Open iDataFile
            Get_Attribute DF_FILE_OPENED Of iDataFile To bOpened
            If (Not (bOpened)) Begin
                Error 304 "Can not open datafile!"
                Send Trap_Error Of Error_Object_Id DFERR_CANT_OPEN_DATA_FILE
                Send Trap_Error Of Error_Object_Id DFERR_FILE_ACCESS_VIOLATION
                Procedure_Return
            End
        
            Get Value Of oFileNameForm To sFileName
            If (sFileName = "") Begin
                Error 300 "You must specify an output filename"
                Procedure_Return
            End
        
            Get Create U_cXMLDomDocument To hoXML
            If (hoXML = 0) Begin
                Error 301 "Can not create a XML DOM object"
                Procedure_Return
            End
        
            Set psDocumentName Of hoXML To sFileName
            Get CreateDocumentElement Of hoXML "Records" To hoRoot
            If (hoRoot = 0) Begin
                Error 302 "For some reason we can not create a root element"
                Send Destroy Of hoXML
                Procedure_Return
            End
        
            Get Checked_State Of oCRLFAtRootCheckbox To bCRLFAtRoot
            If (bCRLFAtRoot) Begin
                Move (Character (13) + Character (10)) To sCRLF
                Send AddChildTextNode Of hoRoot sCRLF
            End
        
            Clear iDataFile
            Repeat
                Vfind iDataFile Recnum Gt
                Move (Finderr) To bEof
                If (Not (bEof)) Begin
                    Get AddElement Of hoRoot "Record" "" To hoRecord
                    If (bCRLFAtRoot) Begin
                        Send AddChildTextNode Of hoRecord sCRLF
                    End
                    If (hoRecord <> 0) Begin
                        Send DoAddFieldsData Of hoFieldsGrid hoRecord iDataFile sCRLF
                        Send Destroy Of hoRecord
                    End
                    If (bCRLFAtRoot) Begin
                        Send AddChildTextNode Of hoRoot sCRLF
                    End
                End
            Until (bEof)
        
            Send Trap_Error Of Error_Object_Id DFERR_CANT_OPEN_DATA_FILE
            Send Trap_Error Of Error_Object_Id DFERR_FILE_ACCESS_VIOLATION
            Close iDataFile
        
            Send Destroy Of hoRoot
            Get SaveXMLDocument Of hoXML To bSaveErr
            If (bSaveErr) Begin
                Error 305 ("Could not save XML document:" * sFileName)
            End
            Send Destroy Of hoXML
        End_Procedure // DoExportData
        //AB-StoreEnd

    End_Object    // oContainer

    Object oExportButton is a Button
        Set Label to "Export"
        Set Location to 169 360
        Set peAnchors to anBottomRight

        //AB-StoreStart
        // During export the cursor shape will be set to an hourglass
        Procedure OnClick
            Send Cursor_Wait Of Cursor_Control
            Send DoExportData Of oContainer
            Send Cursor_Ready Of Cursor_Control
        End_Procedure // OnClick
        //AB-StoreEnd

    End_Object    // oExportButton

CD_End_Object    // oXMLExportView

//AB/ End_Object    // prj
